# Graphical User Interface Wallet - FACTWallet

```
Licence: MIT Licence
Language: Python (>= 3.8)
Homepage: https://www.fact0rn.io
```

The binaries for the FACTWallet can be found here: <https://github.com/FACT0RN/FactWallet/releases>

FACTWallet can also be built from source.

### Getting started

Based on the Bitcoin Electrum Lightweight wallet. See the Contributing section below. There is still a lot of work that needs to be done.

Electrum itself is pure Python, and so are most of the required dependencies, but not everything. The following sections describe how to run from source, but here is a TL;DR:

```
$ sudo apt-get install libsecp256k1-dev
$ python3 -m pip install --user ".[gui,crypto]"
```

#### Not pure-python dependencies

If you want to use the Qt interface, install the Qt dependencies:

```
$ sudo apt-get install python3-pyqt5
```

For elliptic curve operations, [libsecp256k1](https://github.com/bitcoin-core/secp256k1) is a required dependency:

```
$ sudo apt-get install libsecp256k1-dev
```

Alternatively, when running from a cloned repository, a script is provided to build libsecp256k1 yourself:

```
$ sudo apt-get install automake libtool
$ ./contrib/make_libsecp256k1.sh
```

Due to the need for fast symmetric ciphers, [cryptography](https://github.com/pyca/cryptography) is required. Install from your package manager (or from pip):

```
$ sudo apt-get install python3-cryptography
```

If you would like hardware wallet support, [see this](https://github.com/spesmilo/electrum-docs/blob/master/hardware-linux.rst).

#### Running from tar.gz

If you downloaded the official package (tar.gz), you can run Electrum from its root directory without installing it on your system; all the pure python dependencies are included in the 'packages' directory. To run Electrum from its root directory, just do:

```
$ ./run_electrum
```

You can also install Electrum on your system, by running this command:

```
$ sudo apt-get install python3-setuptools python3-pip
$ python3 -m pip install --user .
```

This will download and install the Python dependencies used by Electrum instead of using the 'packages' directory. It will also place an executable named `electrum` in `~/.local/bin`, so make sure that is on your `PATH` variable.

#### Development version (git clone)

*(For OS-specific instructions, see* [*here for Windows*](https://github.com/FACT0RN/FactWallet/blob/master/contrib/build-wine/README_windows.md)*, and* [*for macOS*](https://github.com/FACT0RN/FactWallet/blob/master/contrib/osx/README_macos.md)*)*

Check out the code from GitHub:

```
$ git clone https://github.com/spesmilo/electrum.git
$ cd electrum
$ git submodule update --init
```

Run install (this should install dependencies):

```
$ python3 -m pip install --user -e .
```

Create translations (optional):

```
$ sudo apt-get install python3-requests gettext qttools5-dev-tools
$ ./contrib/pull_locale
```

Finally, to start Electrum:

```
$ ./run_electrum
```

#### Run tests

TODO: tests need to be redone for the Fact0rn blockchain.

Run unit tests with `pytest`:

```
$ pytest electrum/tests -v
```

To run a single file, specify it directly like this:

```
$ pytest electrum/tests/test_bitcoin.py -v
```

### Creating Binaries

* [Linux (tarball)](https://github.com/FACT0RN/FactWallet/blob/master/contrib/build-linux/sdist/README.md)
* [Linux (AppImage)](https://github.com/FACT0RN/FactWallet/blob/master/contrib/build-linux/appimage/README.md)
* [macOS](https://github.com/FACT0RN/FactWallet/blob/master/contrib/osx/README.md)
* [Windows](https://github.com/FACT0RN/FactWallet/blob/master/contrib/build-wine/README.md)
* [Android](https://github.com/FACT0RN/FactWallet/blob/master/contrib/android/Readme.md)

### Contributing

Any help testing the software, reporting or fixing bugs, reviewing pull requests and recent changes, writing tests, or helping with outstanding issues is very welcome. Implementing new features, or improving/refactoring the codebase, is of course also welcome, but to avoid wasted effort, especially for larger changes, we encourage discussing these on the issue tracker or Discord first.

Besides [GitHub](https://github.com/FACT0RN/FactWallet), most communication about Electrum development happens on Discord, in the `Fact0rn` [server](https://discord.gg/Mfzp2QtmQG).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.fact0rn.io/wallet/graphical-user-interface-wallet-factwallet.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
